package com.example.sbcamel.mapper;

import java.util.Collection;
import java.util.UUID;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.type.JdbcType;

import com.example.sbcamel.service.Session;
import com.example.sbcamel.service.UuidTypeHandler;

public interface SessionMapper {

	@Insert({ "<script>",
			"MERGE INTO public.session (sessionId, username, password) KEY (sessionId) VALUES (#{sessionId, javaType=java.util.UUID, "
			+ "jdbcType=OTHER, typeHandler=com.example.sbcamel.service.UuidTypeHandler}, #{username}, #{password}) ",
			"</script>" })
	Session updateSession(Session session);
		
	@Results({ @Result(property = "sessionId", column = "sessionId", javaType=UUID.class, jdbcType=JdbcType.OTHER, typeHandler=UuidTypeHandler.class),
			@Result(property = "username", column = "username"), @Result(property = "password", column = "password") })
	@Select({ "<script>", "select sessionId, username, password from public.session where sessionId=#{list[0], javaType=java.util.UUID, "
			+ "jdbcType=OTHER, typeHandler=com.example.sbcamel.service.UuidTypeHandler}",
			"</script>" })
	Session findSession(UUID sessionId);

	@Results({ @Result(property = "sessionId", column = "sessionId", javaType=UUID.class, jdbcType=JdbcType.OTHER, typeHandler=UuidTypeHandler.class),
			@Result(property = "username", column = "username"), @Result(property = "password", column = "password") })
	@Select({ "<script>", "select sessionId, username, password from public.session order by sessionId", "</script>" })
	Collection<Session> findSessions();
}
