package com.example.sbcamel.service;

import java.io.Serializable;
import java.util.UUID;

import org.apache.commons.lang3.builder.ReflectionToStringBuilder;

import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Size;

/**
 * User entity
 *
 */
@SuppressWarnings("serial")
public class Session implements Serializable {

	private UUID sessionId;

	@NotNull
	@Size(min = 3, max = 40)
	private String username;

	@NotNull
	@Size(min = 3, max = 40)
	private String password;

	public Session() {
	}

	public Session(UUID sessionId, @NotNull @Size(min = 3, max = 40) String username,
			@NotNull @Size(min = 3, max = 40) String password) {
		this.sessionId = sessionId;
		this.username = username;
		this.password = password;
	}

	public UUID getSessionId() {
		return sessionId;
	}

	public void setSessionId(UUID sessionId) {
		this.sessionId = sessionId;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	@Override
	public String toString() {
		return ReflectionToStringBuilder.toString(this);
	}
}