package com.example.sbcamel.service;

import java.util.Collection;
import java.util.UUID;

import jakarta.validation.Valid;
import jakarta.ws.rs.Consumes;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.PathParam;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.core.MediaType;

/**
 * Service interface for managing sessions.
 */
public interface SessionService {

	@POST
	@Path("/session")
	@Consumes(MediaType.APPLICATION_JSON)
	Session updateSession(@Valid Session session);

	@GET
	@Path("/session/{sessionId}")
	@Produces(MediaType.APPLICATION_JSON)
	Session findSession(@PathParam("sessionId") UUID sessionId);

	@GET
	@Path("/session")
	@Produces(MediaType.APPLICATION_JSON)
	Collection<Session> findSessions();
	
	@POST
	@Path("/login/{sessionId}")
	@Produces(MediaType.APPLICATION_JSON)
	Session login(@PathParam("sessionId") UUID sessionId);
}